
package edu.ipvehu.gbg.tap;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @author bcpbogag
 */
public class Babel {
    Map<String,Language> lenguajes=new TreeMap<>();
    
    Babel() throws IOException{
      try (BufferedReader br=
            new BufferedReader(
            new FileReader("udhr/languages.txt"))){ 
          String linea;
          while ((linea=br.readLine())!=null){
                String[] campos=linea.split(" ",2);
                lenguajes.put(campos[0],new Language(campos[0],campos[1],"udhr/txt/"+campos[0]+".txt"));
                  }
      }
    }
    
    
    public Language[] findMostSimilars(String id, int n){
        class Dist implements Comparable{
            Language l; double dist;

            public Dist(Language l, double dist) {
                this.l = l;
                this.dist = dist;
            }
            
            @Override
            public int compareTo(Object obj) {
            if (this == obj) return 0;
            if (obj == null || getClass() != obj.getClass()) return -1;
            return -Double.compare(dist, ((Dist)obj).dist);
            }
        }   
        List<Dist> l=new ArrayList<>();
        Language l1=lenguajes.get(id);
        for(String l2id:lenguajes.keySet()) {
            Language l2=lenguajes.get(l2id);
            if (l1!=l2) l.add(new Dist(l2,Language.similarity(l1, l2)));
        }
        Dist[] a=l.toArray(new Dist[l.size()]);
        Arrays.sort(a);
        Language[] result=new Language[n];
        for (int i=0; i<result.length;i++) result[i]=a[i].l;
        return result;
   }
    
    public Language[] findMostSimilars2(String id, int n){
        class Dist implements Comparable{
            Language l; double dist;

            public Dist(Language l, double dist) {
                this.l = l;
                this.dist = dist;
            }
            
            @Override
            public int compareTo(Object obj) {
            if (this == obj) return 0;
            if (obj == null || getClass() != obj.getClass()) return -1;
            return -Double.compare(dist, ((Dist)obj).dist);
            }
        }   
        List<Dist> l=new ArrayList<>();
        Language l1=lenguajes.get(id);
        for(String l2id:lenguajes.keySet()) {
            Language l2=lenguajes.get(l2id);
            if (l1!=l2) l.add(new Dist(l2,Language.similarity(l1, l2)));
        }
        Dist[] a=l.toArray(new Dist[l.size()]);
        Arrays.sort(a, new Comparator(){
            @Override
            public int compare(Object o1, Object o2) {
                if (o1 == o2) return 0;
                if (o1 == null || o2==null || Dist.class != o1.getClass() || Dist.class != o2.getClass()) return -1;
                return -Double.compare(((Dist)o1).dist, ((Dist)o2).dist); }
        });
        Language[] result=new Language[n];
        for (int i=0; i<result.length;i++) result[i]=a[i].l;
        return result;
   }
    

}
